<?php
// --------------------------------------------------------------//
// Written by: Ben Nelson (Venom)                                //
// Last Modified: 04/27/2000                                     //
// Contact Info: venom@venom600.org                              //
//               www.venom600.org                                //
// --------------------------------------------------------------//
// This file contains all of the functions needed to check and   //
// verify hostnames.  The functions in this file are really only //
// for the host blocking feature of VenomBoard. A lot of work to //
// block a couple of flamers, eh??  Oh well.....necessary evil I //
// guess.                                                        //
// --------------------------------------------------------------//
// PHP version: 3.0.14                                           //
// Apache Version: 1.3.6                                         //
// SQL system: MySQL 3.22.32                                     //
// --------------------------------------------------------------//

// --------------------------------------------------------------//
//                            block()                            //
// --------------------------------------------------------------//
// The name of this function should really be 'block?' because   //
// all it does is check to see if the hostname or IP sent in to  //
// should be blocked.  It returns a 1 for yes and 0 for no.      //
// --------------------------------------------------------------//
function block( $host ) {
  // Let's be nice and give folks the benefit of the doubt by default
  $answer = 0;

  // Connect to the database
  $dbh = db_connect( $db );

  // Form a query to gather all of the blocked hostnames/ip's
  $query = "select type_id,address from hosts_deny";

  // Send the query to the backend
  $res = mysql_query( $query, $dbh );

  // Make sure the query worked
  if( !$res ) {
    db_err( $dbh, "mysql_query:" . $query );
  }

  // The default answer is already 'no', so lets see if we need
  // to even do any checking.
  if( mysql_num_rows( $res ) > 0 ) {
    // Oops...looks like we have some blocked hosts, lets check 'em
    while( (list( $type, $check_host ) = mysql_fetch_row( $res )) && 
	( $answer == 0 ) ) {
      if( $type == 'IP' ) {
        if( $host == $check_host ) { $answer = 1; }
      } else if( $type == 'FQH' ) {
        $hostname = gethostbyaddr( $host );
        if( $hostname == $check_host ) { $answer = 1; }
      } else {
        $answer = 0;
      } // end of inner if statement
    } // end of while loop
  } // end of outer if statement
  
  return( $answer );
}

?>
